/*  aKode: SinkPluginHandler

    Copyright (C) 2004 Allan Sandfeld Jensen <kde@carewolf.com>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "akodelib.h"
#include "sink.h"

namespace aKode {

SinkPluginHandler::SinkPluginHandler(const string lib) : sink_plugin(0)
{
    if (lib.size() > 0);
        load(lib);
}

bool SinkPluginHandler::load(const string name)
{
    bool res = PluginHandler::load(name+"_sink");
    if (res)
        sink_plugin = (SinkPlugin*)loadPlugin(name+"_sink");

    return res && sink_plugin;
}

Sink* SinkPluginHandler::openSink() {
    if (sink_plugin)
        return sink_plugin->openSink();
    else
        return 0;
}

}; //namespace
